"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Intervention(ProtocolElement):
    """
    A process or action that is the focus of a clinical study. Ref.
    https://prsinfo.clinicaltrials.gov/definitions.html
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "interventionName",
        "interventionType",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_10 import reports as reports_6_4_0

        return {
            "interventionType": reports_6_4_0.InterventionType,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_10 import reports as reports_6_4_0

        return {
            "org.gel.models.report.avro.InterventionType": reports_6_4_0.InterventionType,
            "org.gel.models.report.avro.Intervention": reports_6_4_0.Intervention,
        }

    __slots__ = [
        "interventionName",
        "interventionType",
    ]

    def __init__(
        self,
        interventionName,
        interventionType,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_4_0.Intervention model.

        :param interventionName:
            Intervention name: Placebo
        :type interventionName: str
        :param interventionType:
            Intervention type, i.e drug
        :type interventionType: InterventionType
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.4.0"
